"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.object.create");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.regexp.search");

var _global = require("global");

var _qs = _interopRequireDefault(require("qs"));

var _react = _interopRequireDefault(require("react"));

var _ui = require("@storybook/ui");

var _addons = _interopRequireDefault(require("@storybook/addons"));

var _channelPostmessage = _interopRequireDefault(require("@storybook/channel-postmessage"));

var _coreEvents = _interopRequireDefault(require("@storybook/core-events"));

var _preview = _interopRequireDefault(require("./preview"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ReactProvider =
/*#__PURE__*/
function (_Provider) {
  _inherits(ReactProvider, _Provider);

  function ReactProvider() {
    var _this;

    _classCallCheck(this, ReactProvider);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ReactProvider).call(this));
    _this.channel = (0, _channelPostmessage.default)({
      page: 'manager'
    });

    _addons.default.setChannel(_this.channel);

    _this.channel.emit(_coreEvents.default.CHANNEL_CREATED);

    return _this;
  }

  _createClass(ReactProvider, [{
    key: "getPanels",
    value: function getPanels() {
      return _addons.default.getPanels();
    }
  }, {
    key: "renderPreview",
    value: function renderPreview(selectedKind, selectedStory) {
      var queryParams = {
        selectedKind: selectedKind,
        selectedStory: selectedStory
      }; // Add the react-perf query string to the iframe if that present.

      if (/react_perf/.test(_global.location.search)) {
        queryParams.react_perf = '1';
      }

      var queryString = _qs.default.stringify(queryParams);

      var url = "iframe.html?".concat(queryString);
      return _react.default.createElement(_preview.default, {
        url: url
      });
    }
  }, {
    key: "handleAPI",
    value: function handleAPI(api) {
      var _this2 = this;

      api.onStory(function (kind, story) {
        _this2.channel.emit(_coreEvents.default.SET_CURRENT_STORY, {
          kind: kind,
          story: story
        });
      });
      this.channel.on(_coreEvents.default.SET_STORIES, function (data) {
        api.setStories(data.stories);
      });
      this.channel.on(_coreEvents.default.SELECT_STORY, function (data) {
        api.selectStory(data.kind, data.story);
      });
      this.channel.on(_coreEvents.default.APPLY_SHORTCUT, function (data) {
        api.handleShortcut(data.event);
      });

      _addons.default.loadAddons(api);
    }
  }]);

  return ReactProvider;
}(_ui.Provider);

exports.default = ReactProvider;